precision mediump float;

varying vec2      v_angCoord;

uniform sampler2D u_texture;
uniform vec2      u_lensFoV;
uniform vec2      u_lensPP;
uniform vec2      u_lensD;

void main () {

    vec2 uv = u_lensPP + vec2(v_angCoord.x / u_lensFoV.x * u_lensD.x, v_angCoord.y / u_lensFoV.y * u_lensD.y);

    if (uv.x < 0.0 || uv.x > 1.0 || uv.y < 0.0 || uv.y > 1.0) {
        gl_FragColor = vec4(0.0, 0.0, 0.0, 0.0);
    }
    else {
        gl_FragColor = texture2D(u_texture, uv);
    }
}